#include<stdio.h>
#include	"fechas.h"
#include "utilitarios.h"

void Ingresarfecha(t_fecha *fecha)//Funcion para ingresar una fecha
{ printf("Ingrese la fecha (d-m-a):\n");
  scanf("%d-%d-%d",&fecha->dia,&fecha->mes,&fecha->anio);
}

void Ingresarfechajuli(t_fechaj *fecha)//Funcion para ingresar una fecha
{ printf("Ingrese la fecha en formato juliano(d-a):\n");
  scanf("%d-%d",&fecha->dia,&fecha->anio);
}

void Mostrarfecha(t_fecha *fecha)//Funcion para mostrar una fecha
{ printf("La fecha resultante es %d/%d/%d (d-m-a)\n",fecha->dia,fecha->mes,fecha->anio);
}

void Mostrarfechajuli(t_fechaj *fecha)//Funcion para mostrar una fecha juliana
{  printf("\nLa fecha juliana resultante es %d/%d (d-a)\n",fecha->dia,fecha->anio);
}

int Fechavalida(t_fecha *fecha)//Funcion para validar una fecha
{ int fv=0;
  if(fecha->anio>1700)
  {	if((fecha->mes>=1)&&(fecha->mes<=12))
  		{  if((fecha->dia>=1)&&(fecha->dia<=Cantidaddiasmes(fecha->mes,fecha->anio)))
           	fv=1;
      }
  }
  return fv;
}


int Cantidaddiasmes(int mes,int anio)//Funcion para determinar la cantidad de dias que tiene el mes
{  int cantdias=31;
	if((mes==4)||(mes==6)||(mes==9)||(mes==11))
     cantdias=30;
   else
   { if(mes==2)
     { if(Aniobisiesto(anio)==0)
     		cantdias=28;
       else
         cantdias=29;
     }
   }
   return cantdias;
}


int Aniobisiesto(int anio)//Funcion para determinar si es anio bisiesto
{	if(((anio%400)==0)||((anio%4)&&(anio%100))==0)
		return 1;
	else
   	return 0;
}

int Fechavalidajuli(t_fechaj *fechaj)//Funcion para validar una fecha juliana
{ int fv=0;
  if(fechaj->anio>1700)
  {	if((fechaj->dia>=1)&&(fechaj->dia<=Cantidaddiasanio(fechaj->anio)))
        fv=1;
  }
  return fv;
}

int Cantidaddiasanio(int anio)//Funcion para determinar la cantidad de dias que tiene el anio
{	int cantdias=365;
   if(Aniobisiesto(anio)==1)
     cantdias=366;
   return cantdias;
}

int Compararfechas(t_fecha *fecha1,t_fecha *fecha2)//Funcion que compara dos fechas
{ int aux;
  if((fecha1->anio)>(fecha2->anio))
    aux=1;
  else
  { if((fecha1->anio)<(fecha2->anio))
  		aux=(-1);
    else
    {  if((fecha1->mes)>(fecha2->mes))
    		aux=1;
       else
       { if((fecha1->mes)<(fecha2->mes))
       		aux=(-1);
         else
         { if((fecha1->dia)>(fecha2->dia))
         	aux=1;
           else
           { if((fecha1->dia)<(fecha2->dia))
              aux=(-1);
             else
              aux=0;
           }
         }
       }
    }
  }
  return aux;
}


void Sumadiasaunafecha(t_fecha *fecha)//Funcion que suma dias a una fecha
{ int cantdias;
  puts("Ingrese los dias a sumar a la fecha:\n");
  scanf("%d",&cantdias);
  fecha->dia+=cantdias;
  while(fecha->dia>Cantidaddiasmes(fecha->mes,fecha->anio))
  { fecha->dia-=Cantidaddiasmes(fecha->mes,fecha->anio);
  	 if(fecha->mes==12)
    {	fecha->mes=1;
    	fecha->anio++;
    }
    else
    	fecha->mes++;
  }
}


void Restadiasaunafecha(t_fecha *fecha)//Funcion que resta dias a una fecha
{  int cantdias;
   puts("Ingrese los dias a restar a la fecha:\n");
   scanf("%d",&cantdias);
	fecha->dia-=cantdias;
   while((fecha->dia<Cantidaddiasmes(fecha->mes,fecha->anio))&&(fecha->dia<=0))
  { if(fecha->mes==1)
    {	fecha->mes=12;
    	fecha->anio--;
    }
    else
    	fecha->mes--;
    fecha->dia+=Cantidaddiasmes(fecha->mes,fecha->anio);
  }
}


int Cantidaddedias(t_fecha *fecha1,t_fecha *fecha2)//Funcion que determina la cantidad de dias entre dos fechas
{ int aux,cantdias;
  aux=Compararfechas(fecha1,fecha2);
  if(aux==1)
  { cantdias=fecha1->dia-fecha2->dia;
     while(Compararmesanio(fecha2->mes,fecha2->anio,fecha1->mes,fecha1->anio))
    { cantdias+=Cantidaddiasmes(fecha2->mes,fecha2->anio);
      Incrementomesanio(&fecha2->mes,&fecha2->anio);
    }
  }
  else
  { if(aux==(-1))
    {cantdias=fecha1->dia-fecha2->dia;
      while(Compararmesanio(fecha1->mes,fecha1->anio,fecha2->mes,fecha2->anio))
      {  cantdias-=Cantidaddiasmes(fecha1->mes,fecha1->anio);
         Incrementomesanio(&fecha1->mes,&fecha1->anio);
      }
    }
  }
return cantdias;
}

int Compararmesanio(int mesa,int anioa,int mesb,int aniob)//Funcion que compara el mes y el anio
{	if((anioa==aniob)&&(mesa==mesb))
		return 0;
   else
      return 1;
}


void Incrementomesanio(int *mes,int *anio)//Funcion que incrementa el mes y el anio
{  if(*mes==12)
       {  *mes=1;
      	 *anio=*anio+1;
       }
       else
         *mes=*mes+1;
}

void Gregorianaajuliana(t_fecha *fecha)//Funcion de pasaje de gregoriano a juliano
{ t_fechaj fechaj;
  int i;
  for (i=1;i<fecha->mes;i++)
    fecha->dia+=Cantidaddiasmes(i,fecha->anio);      //acumula los dias de los meses desde enero al mes anterior al ingresado
 fechaj.dia=fecha->dia;
 fechaj.anio=fecha->anio;
 Mostrarfechajuli(&fechaj);
 }

void Julianaagregoriana (t_fechaj *fechaj)//Funcion de pasaje de juliano a gregoriano
{ t_fecha fecha;
  int mes=1;
  while (fechaj->dia>Cantidaddiasmes(mes,fechaj->anio))
   {  fechaj->dia-=Cantidaddiasmes(mes,fechaj->anio);
   	mes++;
   }
 fecha.dia=fechaj->dia;
 fecha.mes=mes;
 fecha.anio=fechaj->anio;
 Mostrarfecha(&fecha);
}

char* Diadelasemana(t_fecha *fecha)//Funcion que devuelve el dia de la semana
{  char *dias[7]={"DOMINGO","LUNES","MARTES","MIERCOLES","JUEVES","VIERNES","SABADO"};
   t_fecha fechab={12,4,2009};//Fecha base
	int desp;
   if(Compararfechas(fecha,&fechab)==1)
     desp=(Cantidaddedias(fecha,&fechab)%7);
   else
   {	if(Compararfechas(fecha,&fechab)==0)
       desp=0;
      else
       desp=(7+(Cantidaddedias(fecha,&fechab)%7))%7;
   }
   return dias[desp];
}




